!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine DensityCloud
!
!   * Developer: Kitamori Taichi
!   * Version: $Id: densitycloud_turb-fall.f90,v 1.2 2011-09-12 04:50:20 yamasita Exp $ 
!   * Tag Name: $Name: arare4-20110912 $
!   * Change History: 
!
!== Overview 
!
! ̩٤λȯŸ
! 2 ʬα̩٤ο. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!   * եå򤤤Ƥ
!   * ήȻθ
!   * γθ
!   * ̩٤ΰήȻΤߤ. 
!     ŷʬϰήȻˤα̩٤ηԤʤäǷ׻. 
!  
!== Future Plans
!
                                                                 !=end
subroutine DensityCloud(      & 
  & xz_DensCloudNs,                 & !(in) ̩
  & DelTime,                         & !(in) leapfrog λֳִ
  & pz_VelXNl,                      & !(in) ʿή®
  & xr_VelZNl,                      & !(in) ľή®
  & xz_DensCloudNl,                 & !(in) ̩(ή)
  & xz_DensCloudBl,                 & !(in) ̩(Ȼ)
  & xz_PotTempNl,                   & !(in) ̾()
  & xz_ExnerNl,                     & !(in) ʡ()
  & xz_KhBl,                        & !(in) ήȻ
  & xz_DensCloudWorkAs)           !(out) ̩(̩٤Ĵ)

                                                                 !=begin  
  !== Dependancy
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
!  use bcset,    only: xz_BC
  use average,  only: pz_avr_xz, xr_avr_xz
  use differentiate_center4, only: xz_dx_pz, xz_dz_xr
  use basicset, only: Grav, PressSfc, GasRDry, CpDry, &
               &      xz_ExnerBasicZ, xz_PotTempBasicZ, &
               &      xz_DensBasicZ
  use cloudset, only: DensIce, &        ! ʪ̩
    &                 NumAerosol, &     ! ̤ζŷ˿̩
    &                 RadiAerosol       ! ŷȾ
  use Turbulence, only: xz_TurbScalar
  use NumDiffusion, only: xz_NumDiffScalar

  use StoreDensCloud, only: StoreDensCloudAdv, StoreDensCloudTurb, &
    &                       StoreDensCloudDiff, StoreDensCloudFall
                                                                 !=end
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: DelTime       ! leapfrog λֳִ [s]
  real(8), intent(in)  :: xz_DensCloudNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  real(8), intent(in)  :: pz_VelXNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ʿ® [m/s]
  real(8), intent(in)  :: xr_VelZNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ľ® [m/s]
  real(8), intent(in)  :: xz_ExnerNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ʡؿξʬ [1]
  real(8), intent(in)  :: xz_PotTempNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̤ξʬ [K]
  real(8), intent(in)  :: xz_DensCloudNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  real(8), intent(in)  :: xz_DensCloudBl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  real(8), intent(in)  :: xz_KhBl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ήȻ [kg/m^3]

  !== Output
  real(8), intent(out)  :: xz_DensCloudWorkAs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩(̩Ĵ) [kg/m^3]

                                                                 !=end  
  !== Work
  real(8)  :: xz_FluxDensCloud(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        ! եåˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_FallDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_TurbDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ήȻˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_NumDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! Ǵˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_RadiCloudNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γȾ [m]
  real(8)  :: xz_VelZTerm(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γνü®
  real(8)  :: xz_VisCoffCO2(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 Ǵ
  real(8)  :: xz_MeanFreePath(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 ʿѼͳ
  real(8)  :: xz_KnudsenNum(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γФ Knudsen 
  real, parameter :: Pi = 3.1415926535897932385d0
                                        ! ߼Ψ
  real, parameter :: BoltzmannConst = 1.38065d-23
                                        ! ܥĥޥ
  real, parameter :: CO2Diam = 3.30d-10
                                        ! CO2 ʬҤ kinetic diameter
  real, parameter :: SutherlandConst = 2.40d2
                                        ! CO2 ʬҤΥ
  real, parameter :: VisCoffRef = 1.47d-5
                                        ! Ǵλ
  real, parameter :: TempRef = 2.93d2
                                        ! ǴλȲ

  call BeginSub("DensityCloud", &
       &        fmt="%c",              &
       &        c1="Time integration of density of cloud.")
  
!  write(*,*) xz_DensCloudNl(1,:)

  !=== Ǵη׻
  xz_VisCoffCO2 = &
    & VisCoffRef * (TempRef + SutherlandConst) &
    & / ( (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    &     + SutherlandConst ) &
    & * ( (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    &     / TempRef )**1.5d0

  !=== ʿѼͳη׻
  xz_MeanFreePath = &
    & BoltzMannConst * &
    & (xz_PotTempBasicZ + xz_PotTempNl)*(xz_ExnerBasicZ + xz_ExnerNl) &
    & / ( 2.0**0.5d0 * Pi * (CO2Diam)**2.0d0 * PressSfc &
    &    * (xz_ExnerBasicZ + xz_ExnerNl)**(CpDry/GasRDry) )

  !=== γȾ¤η׻
  xz_RadiCloudNl =   &
    & (  &
    &      3.0d0 * xz_DensCloudNl &
    &      / (4.0d0 * Pi * DensIce * NumAerosol * xz_DensBasicZ) &
    &      + RadiAerosol**3.0d0  &
    &   )**(1.0d0 / 3.0d0)

  !=== Knudsen η׻
  xz_KnudsenNum = &
    & xz_MeanFreePath / xz_RadiCloudNl

  !=== ü®٤η׻
  xz_VelZTerm = &
    & ( 1.0d0 + &
    &   xz_KnudsenNum &
    &   * (1.257d0 + 0.400d0 * exp(- 1.10d0 / xz_KnudsenNum) ) ) &
    & * 2.0d0 * xz_RadiCloudNl * xz_RadiCloudNl * Grav * DensIce  &
    & / (9.0d0 * xz_VisCoffCO2)
!  xz_VelZTerm = 1.0d0 ! ƥ

  !=== η׻. 4 濴ʬѤƷ׻
  xz_FallDensCloud = &
    & xz_dz_xr(xr_avr_xz(xz_VelZTerm) * xr_avr_xz(xz_DensCloudNl))

  call StoreDensCloudFall( xz_FallDensCloud )

  !=== եåη׻. 4 濴ʬѤƷ׻
  xz_FluxDensCloud  = &
    & - xz_dx_pz(pz_VelXNl * pz_avr_xz(xz_DensCloudNl)) &
    & - xz_dz_xr(xr_VelZNl * xr_avr_xz(xz_DensCloudNl))

  call StoreDensCloudAdv( xz_FluxDensCloud )

  call DbgMessage( fmt="*** Debug Message [DensityCloud] *** xz_DensCloud_out ")

  !=== ήȻη׻
  xz_TurbDensCloud = xz_TurbScalar(xz_DensCloudBl, xz_KhBl)

  call StoreDensCloudTurb( xz_TurbDensCloud )

  !=== Ǵη׻
  xz_NumDensCloud = xz_NumDiffScalar(xz_DensCloudBl)

  call StoreDensCloudDiff( xz_NumDensCloud )

  xz_DensCloudWorkAs = xz_DensCloudNs  & 
    & + DelTime * ( xz_FallDensCloud + xz_FluxDensCloud  &
    &  + xz_TurbDensCloud + xz_NumDensCloud ) 

!  !=== 
!  call boundary(xz_BC, xz_DensCloud_out)
!
  call EndSub("DensityCloud")
  
end subroutine DensityCloud
